#!/usr/bin/env python
# Generated python code from maj file

###########
# Imports #
###########
from torch import load as load_file
import torch
import pandas as pd
from sklearn.preprocessing import LabelEncoder

########
# Main #
########
model_pretrainedModel = load_file('pretrainedFile')
learning_rate_model_pretrainedModel = 0.001 # Default learning_rate
batch_size_model_pretrainedModel = 16 # Default batch_size
epochs_model_pretrainedModel = 10 # Default epochs

# Read dataset
data_testDataset = pd.read_csv('test.csv')
X_testDataset = torch.tensor(data_testDataset.iloc[:, :-1].values, dtype=torch.float32)
label_encoder_pretrainedModel = LabelEncoder()
y_encoded_pretrainedModel = label_encoder_pretrainedModel.fit_transform(data_dataset1.iloc[:, -1].values)
y_testDataset = torch.tensor(y_encoded_pretrainedModel, dtype=torch.long)

def evaluate_pretrainedModel():
    model_pretrainedModel.eval()
    val_loss = 0.0
    correct_predictions = 0.0
    total_predictions = 0
    all_targets = []
    all_predicted = []
    with torch.no_grad():
        for inputs, targets in val_loader_testDataset:
            outputs = model_pretrainedModel(inputs)
            loss = criterion_pretrainedModel(outputs, targets)
            val_loss += loss.item()
            _, predicted = torch.max(outputs, 1)
            correct_predictions += (predicted == targets).sum().item()
            total_predictions += targets.size(0)
            all_targets.append(targets)
            all_predicted.append(predicted)
    val_loss /= len(val_loader_testDataset)
    all_targets = torch.cat(all_targets)
    all_predicted = torch.cat(all_predicted)
    print(f'[*] Metrics : ')
    print(f' └──[+] Validation Loss: {val_loss:.4f}') # Default metric

# Evaluate
evaluate_pretrainedModel()


